var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var verify_exports = {};
__export(verify_exports, {
  jwtVerify: () => jwtVerify
});
module.exports = __toCommonJS(verify_exports);
var import_verify = require("../jws/compact/verify.js");
var import_jwt_claims_set = __toESM(require("../lib/jwt_claims_set.js"));
var import_errors = require("../util/errors.js");
async function jwtVerify(jwt, key, options) {
  var _a;
  const verified = await (0, import_verify.compactVerify)(jwt, key, options);
  if (((_a = verified.protectedHeader.crit) == null ? void 0 : _a.includes("b64")) && verified.protectedHeader.b64 === false) {
    throw new import_errors.JWTInvalid("JWTs MUST NOT use unencoded payload");
  }
  const payload = (0, import_jwt_claims_set.default)(verified.protectedHeader, verified.payload, options);
  const result = { payload, protectedHeader: verified.protectedHeader };
  if (typeof key === "function") {
    return { ...result, key: verified.key };
  }
  return result;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  jwtVerify
});
