var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var aeskw_exports = {};
__export(aeskw_exports, {
  unwrap: () => unwrap,
  wrap: () => wrap
});
module.exports = __toCommonJS(aeskw_exports);
var import_buffer = require("buffer");
var import_crypto = require("crypto");
var import_errors = require("../util/errors.js");
var import_buffer_utils = require("../lib/buffer_utils.js");
var import_webcrypto = require("./webcrypto.js");
var import_crypto_key = require("../lib/crypto_key.js");
var import_is_key_object = __toESM(require("./is_key_object.js"));
var import_invalid_key_input = __toESM(require("../lib/invalid_key_input.js"));
var import_ciphers = __toESM(require("./ciphers.js"));
var import_is_key_like = require("./is_key_like.js");
function checkKeySize(key, alg) {
  if (key.symmetricKeySize << 3 !== parseInt(alg.slice(1, 4), 10)) {
    throw new TypeError(`Invalid key size for alg: ${alg}`);
  }
}
function ensureKeyObject(key, alg, usage) {
  if ((0, import_is_key_object.default)(key)) {
    return key;
  }
  if (key instanceof Uint8Array) {
    return (0, import_crypto.createSecretKey)(key);
  }
  if ((0, import_webcrypto.isCryptoKey)(key)) {
    (0, import_crypto_key.checkEncCryptoKey)(key, alg, usage);
    return import_crypto.KeyObject.from(key);
  }
  throw new TypeError((0, import_invalid_key_input.default)(key, ...import_is_key_like.types, "Uint8Array"));
}
const wrap = (alg, key, cek) => {
  const size = parseInt(alg.slice(1, 4), 10);
  const algorithm = `aes${size}-wrap`;
  if (!(0, import_ciphers.default)(algorithm)) {
    throw new import_errors.JOSENotSupported(
      `alg ${alg} is not supported either by JOSE or your javascript runtime`
    );
  }
  const keyObject = ensureKeyObject(key, alg, "wrapKey");
  checkKeySize(keyObject, alg);
  const cipher = (0, import_crypto.createCipheriv)(algorithm, keyObject, import_buffer.Buffer.alloc(8, 166));
  return (0, import_buffer_utils.concat)(cipher.update(cek), cipher.final());
};
const unwrap = (alg, key, encryptedKey) => {
  const size = parseInt(alg.slice(1, 4), 10);
  const algorithm = `aes${size}-wrap`;
  if (!(0, import_ciphers.default)(algorithm)) {
    throw new import_errors.JOSENotSupported(
      `alg ${alg} is not supported either by JOSE or your javascript runtime`
    );
  }
  const keyObject = ensureKeyObject(key, alg, "unwrapKey");
  checkKeySize(keyObject, alg);
  const cipher = (0, import_crypto.createDecipheriv)(algorithm, keyObject, import_buffer.Buffer.alloc(8, 166));
  return (0, import_buffer_utils.concat)(cipher.update(encryptedKey), cipher.final());
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  unwrap,
  wrap
});
