var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var node_key_exports = {};
__export(node_key_exports, {
  default: () => keyForCrypto
});
module.exports = __toCommonJS(node_key_exports);
var import_crypto = require("crypto");
var import_get_named_curve = __toESM(require("./get_named_curve.js"));
var import_errors = require("../util/errors.js");
var import_check_modulus_length = __toESM(require("./check_modulus_length.js"));
const [major, minor] = process.version.slice(1).split(".").map((str) => parseInt(str, 10));
const electron = "electron" in process.versions;
const rsaPssParams = !electron && (major >= 17 || major === 16 && minor >= 9);
const PSS = {
  padding: import_crypto.constants.RSA_PKCS1_PSS_PADDING,
  saltLength: import_crypto.constants.RSA_PSS_SALTLEN_DIGEST
};
const ecCurveAlgMap = /* @__PURE__ */ new Map([
  ["ES256", "P-256"],
  ["ES256K", "secp256k1"],
  ["ES384", "P-384"],
  ["ES512", "P-521"]
]);
function keyForCrypto(alg, key) {
  switch (alg) {
    case "EdDSA":
      if (!["ed25519", "ed448"].includes(key.asymmetricKeyType)) {
        throw new TypeError(
          "Invalid key for this operation, its asymmetricKeyType must be ed25519 or ed448"
        );
      }
      return key;
    case "RS256":
    case "RS384":
    case "RS512":
      if (key.asymmetricKeyType !== "rsa") {
        throw new TypeError("Invalid key for this operation, its asymmetricKeyType must be rsa");
      }
      (0, import_check_modulus_length.default)(key, alg);
      return key;
    case (rsaPssParams && "PS256"):
    case (rsaPssParams && "PS384"):
    case (rsaPssParams && "PS512"):
      if (key.asymmetricKeyType === "rsa-pss") {
        const { hashAlgorithm, mgf1HashAlgorithm, saltLength } = key.asymmetricKeyDetails;
        const length = parseInt(alg.slice(-3), 10);
        if (hashAlgorithm !== void 0 && (hashAlgorithm !== `sha${length}` || mgf1HashAlgorithm !== hashAlgorithm)) {
          throw new TypeError(
            `Invalid key for this operation, its RSA-PSS parameters do not meet the requirements of "alg" ${alg}`
          );
        }
        if (saltLength !== void 0 && saltLength > length >> 3) {
          throw new TypeError(
            `Invalid key for this operation, its RSA-PSS parameter saltLength does not meet the requirements of "alg" ${alg}`
          );
        }
      } else if (key.asymmetricKeyType !== "rsa") {
        throw new TypeError(
          "Invalid key for this operation, its asymmetricKeyType must be rsa or rsa-pss"
        );
      }
      (0, import_check_modulus_length.default)(key, alg);
      return { key, ...PSS };
    case (!rsaPssParams && "PS256"):
    case (!rsaPssParams && "PS384"):
    case (!rsaPssParams && "PS512"):
      if (key.asymmetricKeyType !== "rsa") {
        throw new TypeError("Invalid key for this operation, its asymmetricKeyType must be rsa");
      }
      (0, import_check_modulus_length.default)(key, alg);
      return { key, ...PSS };
    case "ES256":
    case "ES256K":
    case "ES384":
    case "ES512": {
      if (key.asymmetricKeyType !== "ec") {
        throw new TypeError("Invalid key for this operation, its asymmetricKeyType must be ec");
      }
      const actual = (0, import_get_named_curve.default)(key);
      const expected = ecCurveAlgMap.get(alg);
      if (actual !== expected) {
        throw new TypeError(
          `Invalid key curve for the algorithm, its curve must be ${expected}, got ${actual}`
        );
      }
      return { dsaEncoding: "ieee-p1363", key };
    }
    default:
      throw new import_errors.JOSENotSupported(
        `alg ${alg} is not supported either by JOSE or your javascript runtime`
      );
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
