var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var pbes2kw_exports = {};
__export(pbes2kw_exports, {
  decrypt: () => decrypt,
  encrypt: () => encrypt
});
module.exports = __toCommonJS(pbes2kw_exports);
var import_util = require("util");
var import_crypto = require("crypto");
var import_random = __toESM(require("./random.js"));
var import_buffer_utils = require("../lib/buffer_utils.js");
var import_base64url = require("./base64url.js");
var import_aeskw = require("./aeskw.js");
var import_check_p2s = __toESM(require("../lib/check_p2s.js"));
var import_webcrypto = require("./webcrypto.js");
var import_crypto_key = require("../lib/crypto_key.js");
var import_is_key_object = __toESM(require("./is_key_object.js"));
var import_invalid_key_input = __toESM(require("../lib/invalid_key_input.js"));
var import_is_key_like = require("./is_key_like.js");
const pbkdf2 = (0, import_util.promisify)(import_crypto.pbkdf2);
function getPassword(key, alg) {
  if ((0, import_is_key_object.default)(key)) {
    return key.export();
  }
  if (key instanceof Uint8Array) {
    return key;
  }
  if ((0, import_webcrypto.isCryptoKey)(key)) {
    (0, import_crypto_key.checkEncCryptoKey)(key, alg, "deriveBits", "deriveKey");
    return import_crypto.KeyObject.from(key).export();
  }
  throw new TypeError((0, import_invalid_key_input.default)(key, ...import_is_key_like.types, "Uint8Array"));
}
const encrypt = async (alg, key, cek, p2c = 2048, p2s = (0, import_random.default)(new Uint8Array(16))) => {
  (0, import_check_p2s.default)(p2s);
  const salt = (0, import_buffer_utils.p2s)(alg, p2s);
  const keylen = parseInt(alg.slice(13, 16), 10) >> 3;
  const password = getPassword(key, alg);
  const derivedKey = await pbkdf2(password, salt, p2c, keylen, `sha${alg.slice(8, 11)}`);
  const encryptedKey = await (0, import_aeskw.wrap)(alg.slice(-6), derivedKey, cek);
  return { encryptedKey, p2c, p2s: (0, import_base64url.encode)(p2s) };
};
const decrypt = async (alg, key, encryptedKey, p2c, p2s) => {
  (0, import_check_p2s.default)(p2s);
  const salt = (0, import_buffer_utils.p2s)(alg, p2s);
  const keylen = parseInt(alg.slice(13, 16), 10) >> 3;
  const password = getPassword(key, alg);
  const derivedKey = await pbkdf2(password, salt, p2c, keylen, `sha${alg.slice(8, 11)}`);
  return (0, import_aeskw.unwrap)(alg.slice(-6), derivedKey, encryptedKey);
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  decrypt,
  encrypt
});
